%ic7_2.m
%Coded by LTR on 9/17/19
%Piecewise polynomial interpolation

clear ; clf ;
load ic7 %Runge's function
%x_big and y_big should be thought of as the "true" function
plot(x_big,y_big,'linewidth',3)
hold on
%x and y are discrete data, such as what we'd measure experimentally
plot(x,y,'ro','markersize',12,'markerface','r')

%Simplest method of piecewise interpolation: linear piecewise polynomial
p1_first = polyfit(x(1:2),y(1:2),1)

%Could create all of our polynomial segments in a loop...
%Step 1: initialize
%In each row, we have a different segment of the plot
%Columns store the polynomial for each segment
p1 = zeros(length(x)-1,2);
for ii = 1:length(x) - 1
    p1(ii,:) = polyfit(x(ii:ii+1),y(ii:ii+1),1);
    x_interp = linspace(x(ii),x(ii+1));
    p1_y = polyval(p1(ii,:),x_interp);
    plot(x_interp,p1_y,'r','linewidth',3)
end

%Could do this more efficiently with interp1
%interp1 syntax: interp1(xdata,ydata,x_interp,'method')

x_int = linspace(x(1),x(end));
y_int = interp1(x,y,x_int,'linear');
%if we want a specific value, say, y at x = 3.5
y_int3_5 = interp1(x,y,3.5,'linear');

%interp1 default: linear interpolation
%other options:
%'nearest', 'next', 'previous'
%'spline'
%'pchip' or 'cubic'

plot(x_int,y_int,'g-','linewidth',3)

%Shortcomings: Missing curvature, sharp corners (slopes aren't matching...)
%slope doesn't match: 1st derivative not continuous at our points.






