%ic7_3.m
%Coded by LTR on 9/17/19
%Spline interpolation

clear ; clf ;
load ic7 %Runge's function
%x_big and y_big should be thought of as the "true" function
plot(x_big,y_big,'linewidth',3)
hold on
%x and y are discrete data, such as what we'd measure experimentally
plot(x,y,'ro','markersize',12,'markerface','r')

%Splines: continuous at endpoints, continuous 1st and 2nd derivatives
%Creating a cubic polynomial (normally) for each segment of data.
%10 data points: 9 (unique) cubic polynomials.
%Cubic polynomial: ax^3 + bx^2 + cx + d : 4 degrees of freedom
%Using DOFs: specify continuity at endpoints (1, 2)
%Specify continuity of 1st and 2nd derivs (3, 4)

%Create list of points to interpolate at
x_spline = linspace(x(1),x(end));
%Use 'spline' function to interpolate
y_spline = spline(x,y,x_spline);
%save spline coefficients:
pp_notaknot = spline(x,y) %no x-interpolant says to save coefficients
plot(x_spline,y_spline,'r-','linewidth',3)
%could also use interp1 if we wanted, change method to 'spline'
%This is a "not-a-knot" spline
%We have 2 extra degrees of freedom, which allows us to choose different
%types of splines.
%"not-a-knot" - MATLAB default - continuity of 3rd derivatives at end segments

%clamped splines: specify value of the derivative at endpoints
%useful when we know about the function (physical meaning)
%We provide the derivatives at endpoints as extra "y" values
pp_clamped = spline(x,[1 y 4]);
y_spline = ppval(pp_clamped,x_spline);
plot(x_spline,y_spline,'g-','linewidth',3)
%ONLY use clamped splines when we know derivatives...

%Natural spline: 2nd derivatives are 0 at endpoints
%Manifests in nature, frequently
spl_nat = csape(x,y,'natural'); %Need curve fitting toolbox
%can evaluate spl_nat using ppval, as other types of splines




