%ic7_4.m
%Coded by LTR, 9/17/19
clear; clf

%Temps on a 2-D heated plate
%x- and y-coordinates
x = 0:2:6; y = x;

Z = [27 30 39 55; 
     35 38 49 70; 
     48 54 64 85; 
     70 80 90 100];

[X, Y] = meshgrid(x,y)
%meshgrid: sets up 2D X and Y grids for easier ploting/manipulation
%Advantage: these will have same shape as "z" matrix

%Create surface plots
surf(X,Y,Z) %alternatively, "surfc" gives surface + contour
xlabel('x');ylabel('y');zlabel('T, degC')

%How to interpolate at 3.7, 4.2?
%interp2 works similarly to interp1
z_interp = interp2(X,Y,Z,3.7,4.2,'linear')

%Adding notes/points to our surface plot
hold on
plot3(3.7,4.2,z_interp,'ro','markerface','r')
%plot3 3-D plotting of data
%(plots red marker at our interpolated point)
txt = '\leftarrow We interpolated here';
text(3.7,4.2,66,txt) %drops text at the specified coordinates
%Note: don't need a "z" coordinate if dropping on a 2D x-y plot








 
 